package de.theserverside.designpatterns.factorymethod;

/**
 * Testet die Implementation des Factory Method Pattern
 */
public class FactoryMethodMain {

	public static void main(String[] args) {
		/*
		 * Hersteller Volkswagen und BMW instanziieren
		 */
		AbstrakterHersteller vw = new Volkswagen();
		AbstrakterHersteller bmw = new BMW();
		
		/*
		 * Ausgabe der Fahrzeuge eines jeden Herstellers
		 */
		for (AbstraktesFahrzeug fahrzeug : vw.getFahrzeuge()) {
			System.out.println(
					fahrzeug.getHersteller() + " " + 
					fahrzeug.getModell() + ", " +
					fahrzeug.getKw() + " KW");
		}

		for (AbstraktesFahrzeug fahrzeug : bmw.getFahrzeuge()) {
			System.out.println(
					fahrzeug.getHersteller() + " " + 
					fahrzeug.getModell() + ", " +
					fahrzeug.getKw() + " KW");
		}
	}
}